#ifndef GOCUSTOMUSER_H
#define GOCUSTOMUSER_H

#include "include.h"

class GoClientUser : public ClientUser {

public:
    GoClientUser();

    void clear();
    FileSys *getEditFs();
    const char* getErrorPause();
    const char* getOutputError();
    const char* getOutputInfo();
    const char* getOutputText();
    void setInputData(const char *data);

    void Edit(FileSys *fs, Error *e);

    void ErrorPause(char *buf, Error *e);

    void Finished();

    void HandleError(Error *e);

    void Help(const char * const* help);

    void OutputBinary(const char *buf, int length);

    void OutputInfo(char level, const char *data);

    void OutputText(const char *errBuf, int length);

    void InputData(StrBuf *buf, Error *e);

    void Prompt(const StrPtr &msg, StrBuf &rsp, int noEcho, Error *e);

private:
    FileSys *editFs;
    StrBuf errorPause;
    StrBuf inputData;
    StrBuf outputError;
    StrBuf outputInfo;
    StrBuf outputText;
};

#endif